# L'art du camouflage informatique

* **Note** : ce document au format markdown est mis en forme dans VSCode par F1->Markdown ou ctrl+maj+v si l'extension markdownlint est installée.

Le code du fichier Python steganographie est extrait de l'article "L'art du camouflage informatique" à <html><a href="https://webge.fr/doc/projets/tnsi/Art du camouflage informatique.zip" title="WebGE"> télécharger</a></html>. Les fonctions sont décrites dans le code.

## Contenu de TNSI_EX_PY_CAMOUFLAGE

* Le dossier **A lire** contient le fichier L'Art du camouflage informatique.png.
* Le dossier **img** contient l'image d'origine *lena.png* et l'image *out.png* = *lena.png* + le message à cacher.
* Le fichier Python *testyield* est une aide pour tester le comportement de la fonction yield.
* Le fichier Python *steganographie* contient le code permettant de camoufler et retrouver un message dans une image.

## Algorithme stenographie_LSB

    // var
    t <- taille du message
    t_bin <- conversion binaire de t
    msg <- le message textuel
    img <- Image à modifier avec le message
    code <- copie de l'Image
    tete_ecriture <- (p0,0) // pixel 0, composante 0 pour rouge

    // Intégrer la taille du message à la copie de l'image
    Pour chaque bit b de t_bin Faire
        Remplacer par b le bit de poids faible de tete_ecriture
        tete_ecriture <- tete_ecriture suivante(pixel ou composante RVB)
    Avancer tete_ecriture jusqu'au pixel suivant

    // Intégrer le message à la copie de l'image
    Pour chaque caractère car du message msg Faire
        car_bin <- conversion binaire de car
        Pour chaque bit b de car_bin Faire
            Remplacer par b le bit de poids faible de tete_ecriture
            tete_ecriture <- tete_ecriture suivante(pixel ou composante)
    Avancer tete_ecriture jusqu'au pixel suivant

    // Sauvegarder 
    Ecrire la copie de l'image sur le disque

## Utilisation de steganographie.py

A exécuter dans VSCode (IPYthon)

![IPYTHON](Alire/ipython.png "Cliquer sur RUN Cell")

## Résultat

* **Camouflage** du message GNU/Linux Magazine dans out.png

![camouflage](Alire/camouflage.png)

* **Extraction** du message GNU/Linux Magazine de out.png

![extraction](Alire/extraction.png)